<?php
/**
 * -----------------------------------------------------------------------------
 *
 * SyL - Web Application Framework for PHP
 *
 * PHP version 4 (>= 4.3.x) or 5
 *
 * Copyright (C) 2006-2008 k.watanabe
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * -----------------------------------------------------------------------------
 * @package   SyL
 * @author    Koki Watanabe <k.watanabe@syl.jp>
 * @copyright 2006-2008 k.watanabe
 * @license   http://www.opensource.org/licenses/lgpl-license.php
 * @version   CVS: $Id: SyL_ConfigDefines.php,v 1.22 2008/12/01 17:45:52 seasonstream Exp $
 * @link      http://www.syl.jp/
 * -----------------------------------------------------------------------------
 */

/**
 * եɤ߹ߡ륯饹
 *
 * @package   SyL
 * @author    Koki Watanabe <k.watanabe@syl.jp>
 * @copyright 2006-2008 k.watanabe
 * @license   http://www.opensource.org/licenses/lgpl-license.php
 * @version   CVS: $Id: SyL_ConfigDefines.php,v 1.22 2008/12/01 17:45:52 seasonstream Exp $
 * @link      http://www.syl.jp/
 */
class SyL_ConfigDefines extends SyL_Config
{
    /**
     * ե̾
     * 
     * @access private
     * @var string
     */
    var $config_file_name = 'defines.xml';

    /**
     * ե򥻥å
     *
     * @access protected
     */
    function setProjectConfigFiles()
    {
        // ץꥱͤɤ߹
        $config = SYL_APP_CONFIG_DIR . "/{$this->config_file_name}";
        if (is_file($config)) {
            $this->file_names[] = $config;
        }
        // ץͤɤ߹
        $this->file_names[] = SYL_PROJECT_CONFIG_DIR . "/{$this->config_file_name}";
    }

    /**
     * ե򥻥å
     *
     * @access public
     * @param string or array եΥѥ
     * @param bool ץե̵ե饰
     */
    function setConfigFiles($config, $this_only=true)
    {
        if ($this_only) {
            $this->file_names = array();
        }
        if (!is_array($config)) {
            $config = (array)$config;
        }
        $this->file_names = array_merge($this->file_names, $config);
    }

    /**
     * XMLեβϽ
     *
     * @access public
     * @param bool åͭե饰
     * @param bool Ѵե饰
     */
    function parseXml($enable_cache=true, $change_constants=true)
    {
        if (SYL_CACHE && $enable_cache) {
            // åѤ
            $key = SYL_APP_DIR;
            $cache =& $this->getCache($key);
            if ($cache) {
                // å夬Ǥʤäʥå奪֥Ȥ
                parent::parseXml();
                // å¸
                //$cache->setSerialize(false);
                $cache->write($this->config);
            }
        } else {
            // åѤʤ
            parent::parseXml();
        }

        // Ѵ
        if ($change_constants) {
            $this->readConstants();
        }
    }

    /**
     * XMLǡƼϥɥ᥽å
     * С饤
     *
     * @access protected
     * @param string XMLΥѥ
     * @param string XMLΥ°
     * @param string XMLΥ
     */
    function getElement($current_path, $attribute, $text)
    {
        if ($current_path == '/syl-defines/define') {
            $this->config[$attribute['name']] = $text;
        }
    }

    /**
     * ɤ߹
     *
     * @access private
     */
    function readConstants()
    {
        static $defined = false;
        foreach ($this->config as $key => $value) {
            $value = preg_replace_callback('/\{(\w+)\}/', array(&$this, 'replaceConstants'), $value);
            $this->config[$key] = $value;
            if (!$defined) define($key, $value);
        }
        $defined = true;
    }

    /**
     * ֤Хå᥽å
     *
     * @access private
     * @param array ޥå
     * @return mixed ޥå
     */
    function replaceConstants($matches)
    {
        if (isset($this->config[$matches[1]])) {
            return $this->config[$matches[1]];
    } else if (defined($matches[1])) {
            return constant($matches[1]);
        } else {
            return '{' . $matches[1] . '}';
        }
    }
}

?>
