<?php
/**
 * -----------------------------------------------------------------------------
 *
 * SyL - Web Application Framework for PHP
 *
 * PHP version 4 (>= 4.3.x) or 5
 *
 * Copyright (C) 2006-2008 k.watanabe
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * -----------------------------------------------------------------------------
 * @package   SyL
 * @author    Koki Watanabe <k.watanabe@syl.jp>
 * @copyright 2006-2008 k.watanabe
 * @license   http://www.opensource.org/licenses/lgpl-license.php
 * @version   CVS: $Id: SyL_WebServiceMarketItemCodeSearchResponse.php,v 1.1 2008/03/01 05:01:22 seasonstream Exp $
 * @link      http://www.syl.jp/
 * -----------------------------------------------------------------------------
 */

/**
 * WEBӥ쥹ݥ󥹥饹ʳŷ - ŷʥɸAPIѡ
 *
 * ܺ٤ϡŷ֥ӥ󥿡
 *   http://webservice.rakuten.co.jp/
 * ŷʥɸAPI 
 *   http://webservice.rakuten.co.jp/api/genresearch/
 *
 * @package   SyL
 * @author    Koki Watanabe <k.watanabe@syl.jp>
 * @copyright 2006-2008 k.watanabe
 * @license   http://www.opensource.org/licenses/lgpl-license.php
 * @version   CVS: $Id: SyL_WebServiceMarketItemCodeSearchResponse.php,v 1.1 2008/03/01 05:01:22 seasonstream Exp $
 * @link      http://www.syl.jp/
 */
class SyL_WebServiceMarketItemCodeSearchResponse extends SyL_WebServiceRakuten_co_jpResponse
{
    /**
     * ʾ
     *
     * @access private
     * @var array
     */
    var $genreId = array();

    /**
     * XMLǡƼϥɥ᥽å
     *
     * @access protected
     * @param string XMLΥѥ
     * @param string XMLΥ°
     * @param string XMLΥ
     */
    function getElement($current_path, $attribute, $text)
    {
        switch ($current_path) {
        // =============================
        // 
        // =============================
        // ꥢ
        case '/Response/Body/itemCodeSearch:ItemCodeSearch/Item/carrier': $this->item['carrier'] = $text; break;
        // ̾
        case '/Response/Body/itemCodeSearch:ItemCodeSearch/Item/itemName': $this->item['itemName'] = $text; break;
        // ʥ
        case '/Response/Body/itemCodeSearch:ItemCodeSearch/Item/itemCode': $this->item['itemCode'] = $text; break;
        // ʲ
        case '/Response/Body/itemCodeSearch:ItemCodeSearch/Item/itemPrice': $this->item['itemPrice'] = $text; break;
        // ʸ
        case '/Response/Body/itemCodeSearch:ItemCodeSearch/Item/itemCaption': $this->item['itemCaption'] = $text; break;
        // URL
        case '/Response/Body/itemCodeSearch:ItemCodeSearch/Item/itemUrl': $this->item['itemUrl'] = $text; break;
        // եꥨURL
        case '/Response/Body/itemCodeSearch:ItemCodeSearch/Item/affiliateUrl': $this->item['affiliateUrl'] = $text; break;
        // ʲ̵ͭե饰
        case '/Response/Body/itemCodeSearch:ItemCodeSearch/Item/imageFlag': $this->item['imageFlag'] = $text; break;
        // ʲ 64x64URL
        case '/Response/Body/itemCodeSearch:ItemCodeSearch/Item/smallImageUrl': $this->item['smallImageUrl'] = $text; break;
        // ʲ 128x128URL
        case '/Response/Body/itemCodeSearch:ItemCodeSearch/Item/mediumImageUrl': $this->item['mediumImageUrl'] = $text; break;
        // ǽե饰
        case '/Response/Body/itemCodeSearch:ItemCodeSearch/Item/availability': $this->item['availability'] = $text; break;
        // ǥե饰
        case '/Response/Body/itemCodeSearch:ItemCodeSearch/Item/taxFlag': $this->item['taxFlag'] = $text; break;
        // ե饰
        case '/Response/Body/itemCodeSearch:ItemCodeSearch/Item/postageFlag': $this->item['postageFlag'] = $text; break;
        // 쥸åȥѲǽե饰
        case '/Response/Body/itemCodeSearch:ItemCodeSearch/Item/creditCardFlag': $this->item['creditCardFlag'] = $text; break;
        // åץ֥䡼ե饰
        case '/Response/Body/itemCodeSearch:ItemCodeSearch/Item/shopOfTheYearFlag': $this->item['shopOfTheYearFlag'] = $text; break;
        // եꥨΨ
        case '/Response/Body/itemCodeSearch:ItemCodeSearch/Item/affiliateRate': $this->item['affiliateRate'] = $text; break;
        // 䳫ϻ
        case '/Response/Body/itemCodeSearch:ItemCodeSearch/Item/startTime': $this->item['startTime'] = $text; break;
        // 佪λ
        case '/Response/Body/itemCodeSearch:ItemCodeSearch/Item/endTime': $this->item['endTime'] = $text; break;
        // ӥ塼
        case '/Response/Body/itemCodeSearch:ItemCodeSearch/Item/reviewCount': $this->item['reviewCount'] = $text; break;
        // ӥ塼ʿ
        case '/Response/Body/itemCodeSearch:ItemCodeSearch/Item/reviewAverage': $this->item['reviewAverage'] = $text; break;
        // Ź̾
        case '/Response/Body/itemCodeSearch:ItemCodeSearch/Item/shopName': $this->item['shopName'] = $text; break;
        // Źޥ
        case '/Response/Body/itemCodeSearch:ItemCodeSearch/Item/shopCode': $this->item['shopCode'] = $text; break;
        // ŹURL
        case '/Response/Body/itemCodeSearch:ItemCodeSearch/Item/shopUrl': $this->item['shopUrl'] = $text; break;
        // ID
        case '/Response/Body/itemCodeSearch:ItemCodeSearch/Item/genreId': $this->item['genreId'] = $text; break;

        // 嵭ʳ
        default: parent::getElement($current_path, $attribute, $text);
        }
    }

    /**
     * ʾ
     *
     * @access public
     * @param string ̾
     * @return mixed ʾ
     */
    function getItem($name=null)
    {
        if ($name !== null) {
            return isset($this->item[$name]) ? $this->item[$name] : null;
        } else {
            return $this->item;
        }
    }
}

?>
