<?php
/**
 * -----------------------------------------------------------------------------
 *
 * SyL - Web Application Framework for PHP
 *
 * PHP version 4 (>= 4.3.x) or 5
 *
 * Copyright (C) 2006-2008 k.watanabe
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * -----------------------------------------------------------------------------
 * @package   SyL
 * @author    Koki Watanabe <k.watanabe@syl.jp>
 * @copyright 2006-2008 k.watanabe
 * @license   http://www.opensource.org/licenses/lgpl-license.php
 * @version   CVS: $Id: SyL_WebServiceTravelGetAreaClassResponse.php,v 1.1 2008/03/01 05:01:22 seasonstream Exp $
 * @link      http://www.syl.jp/
 * -----------------------------------------------------------------------------
 */

/**
 * WEBӥ쥹ݥ󥹥饹ʳŷ - ŷȥ٥϶襳APIѡ
 *
 * ܺ٤ϡŷ֥ӥ󥿡
 *   http://webservice.rakuten.co.jp/
 * ŷȥ٥϶襳API  
 *   http://webservice.rakuten.co.jp/api/getareaclass/
 *
 * @package   SyL
 * @author    Koki Watanabe <k.watanabe@syl.jp>
 * @copyright 2006-2008 k.watanabe
 * @license   http://www.opensource.org/licenses/lgpl-license.php
 * @version   CVS: $Id: SyL_WebServiceTravelGetAreaClassResponse.php,v 1.1 2008/03/01 05:01:22 seasonstream Exp $
 * @link      http://www.syl.jp/
 */
class SyL_WebServiceTravelGetAreaClassResponse extends SyL_WebServiceRakuten_co_jpResponse
{
    /**
     * ʬ
     *
     * @access private
     * @var array
     */
    var $largeClasses = array();

    /**
     * XMLǡƼϥɥ᥽å
     *
     * @access protected
     * @param string XMLΥѥ
     * @param string XMLΥ°
     * @param string XMLΥ
     */
    function getElement($current_path, $attribute, $text)
    {
        static $i = -1;
        static $j = -1;
        static $k = -1;
        static $l = -1;
        
        switch ($current_path) {
        // =============================
        // 
        // =============================
        // ʬ
        case '/Response/Body/getAreaClass:GetAreaClass/largeClass':
            $i++;
            $j = -1;
            $k = -1;
            $l = -1;
            break;
        // ʬ
        case '/Response/Body/getAreaClass:GetAreaClass/largeClass/largeClassCode':
            $this->largeClasses[$i]['largeClassCode'] = $text;
            break;
        // ʬ̾
        case '/Response/Body/getAreaClass:GetAreaClass/largeClass/largeClassName':
            $this->largeClasses[$i]['largeClassName'] = $text;
            break;

        // ʬ
        case '/Response/Body/getAreaClass:GetAreaClass/largeClass/middleClass':
            $j++;
            $k = -1;
            $l = -1;
            //$this->largeClasses[$i]['middleClass'] = array();
            break;
        // ʬ
        case '/Response/Body/getAreaClass:GetAreaClass/largeClass/middleClass/middleClassCode':
            $this->largeClasses[$i]['middleClass'][$j]['middleClassCode'] = $text;
            break;
        // ʬ̾
        case '/Response/Body/getAreaClass:GetAreaClass/largeClass/middleClass/middleClassName':
            $this->largeClasses[$i]['middleClass'][$j]['middleClassName'] = $text;
            break;

        // ʬ
        case '/Response/Body/getAreaClass:GetAreaClass/largeClass/middleClass/smallClass':
            $k++;
            $l = -1;
            //$this->largeClasses[$i]['middleClass'][$j]['smallClass'] = array();
            break;
        // ʬ
        case '/Response/Body/getAreaClass:GetAreaClass/largeClass/middleClass/smallClass/smallClassCode':
            $this->largeClasses[$i]['middleClass'][$j]['smallClass'][$k]['smallClassCode'] = $text;
            break;
        // ʬ̾
        case '/Response/Body/getAreaClass:GetAreaClass/largeClass/middleClass/smallClass/smallClassName':
            $this->largeClasses[$i]['middleClass'][$j]['smallClass'][$k]['smallClassName'] = $text;
            break;

        // ٶʬ
        case '/Response/Body/getAreaClass:GetAreaClass/largeClass/middleClass/smallClass/detailClass':
            $l++;
            //$this->largeClasses[$i]['middleClass'][$j]['smallClass'][$k]['detailClass'] = array();
            break;
        // ٶʬ
        case '/Response/Body/getAreaClass:GetAreaClass/largeClass/middleClass/smallClass/detailClass/detailClassCode':
            $this->largeClasses[$i]['middleClass'][$j]['smallClass'][$k]['detailClass'][$l]['detailClassCode'] = $text;
            break;
        // ٶʬ̾
        case '/Response/Body/getAreaClass:GetAreaClass/largeClass/middleClass/smallClass/detailClass/detailClassName':
            $this->largeClasses[$i]['middleClass'][$j]['smallClass'][$k]['detailClass'][$l]['detailClassName'] = $text;
            break;

        // 嵭ʳ
        default: parent::getElement($current_path, $attribute, $text);
        }
    }

    /**
     * ʬ
     *
     * @access public
     * @return array ʬ
     */
    function getLargeClasses()
    {
        return $this->largeClasses;
    }
}

?>
