<?php
/**
 * -----------------------------------------------------------------------------
 *
 * SyL - Web Application Framework for PHP
 *
 * PHP version 4 (>= 4.3.x) or 5
 *
 * Copyright (C) 2006-2008 k.watanabe
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * -----------------------------------------------------------------------------
 * @package   SyL
 * @author    Koki Watanabe <k.watanabe@syl.jp>
 * @copyright 2006-2008 k.watanabe
 * @license   http://www.opensource.org/licenses/lgpl-license.php
 * @version   CVS: $Id: SyL_WebServiceTravelVacantHotelSearchResponse.php,v 1.1 2008/03/01 05:01:22 seasonstream Exp $
 * @link      http://www.syl.jp/
 * -----------------------------------------------------------------------------
 */

/**
 * WEBӥ쥹ݥ󥹥饹ʳŷ - ŷȥ٥APIѡ
 *
 * ܺ٤ϡŷ֥ӥ󥿡
 *   http://webservice.rakuten.co.jp/
 * ŷȥ٥API  
 *   http://webservice.rakuten.co.jp/api/vacanthotelsearch/
 *
 * @package   SyL
 * @author    Koki Watanabe <k.watanabe@syl.jp>
 * @copyright 2006-2008 k.watanabe
 * @license   http://www.opensource.org/licenses/lgpl-license.php
 * @version   CVS: $Id: SyL_WebServiceTravelVacantHotelSearchResponse.php,v 1.1 2008/03/01 05:01:22 seasonstream Exp $
 * @link      http://www.syl.jp/
 */
class SyL_WebServiceTravelVacantHotelSearchResponse extends SyL_WebServiceRakuten_co_jpResponse
{
    /**
     * 
     *
     * @access private
     * @var array
     */
    var $rooms = array();
    /**
     * ߾
     *
     * @access private
     * @var array
     */
    var $hotels = array();

    /**
     * XMLǡƼϥɥ᥽å
     *
     * @access protected
     * @param string XMLΥѥ
     * @param string XMLΥ°
     * @param string XMLΥ
     */
    function getElement($current_path, $attribute, $text)
    {
        static $i = -1;
        static $j = -1;

        switch ($current_path) {
        // =============================
        // 
        // =============================
        case '/Response/Body/vacantHotelSearch:VacantHotelSearch/room': $i++; break;
        // ֹ
        case '/Response/Body/vacantHotelSearch:VacantHotelSearch/room/hotelNo': $this->rooms[$i]['hotelNo'] = $text; break;
        // 
        case '/Response/Body/vacantHotelSearch:VacantHotelSearch/room/roomClass': $this->rooms[$i]['roomClass'] = $text; break;
        // ̾
        case '/Response/Body/vacantHotelSearch:VacantHotelSearch/room/roomName': $this->rooms[$i]['roomName'] = $text; break;
        // ץID
        case '/Response/Body/vacantHotelSearch:VacantHotelSearch/room/planId': $this->rooms[$i]['planId'] = $text; break;
        // ץ̾
        case '/Response/Body/vacantHotelSearch:VacantHotelSearch/room/planName': $this->rooms[$i]['planName'] = $text; break;
        // ץ
        case '/Response/Body/vacantHotelSearch:VacantHotelSearch/room/planContents': $this->rooms[$i]['planContents'] = $text; break;
        // ŷݥͿΨ
        case '/Response/Body/vacantHotelSearch:VacantHotelSearch/room/pointRate': $this->rooms[$i]['pointRate'] = $text; break;
        // ͼ̵ͭե饰
        case '/Response/Body/vacantHotelSearch:VacantHotelSearch/room/withDinnerFlag': $this->rooms[$i]['withDinnerFlag'] = $text; break;
        // ͼե饰
        case '/Response/Body/vacantHotelSearch:VacantHotelSearch/room/dinnerSelectFlag': $this->rooms[$i]['dinnerSelectFlag'] = $text; break;
        // ī̵ͭե饰
        case '/Response/Body/vacantHotelSearch:VacantHotelSearch/room/withBreakfastFlag': $this->rooms[$i]['withBreakfastFlag'] = $text; break;
        // īե饰
        case '/Response/Body/vacantHotelSearch:VacantHotelSearch/room/breakfastSelectFlag': $this->rooms[$i]['breakfastSelectFlag'] = $text; break;
        // ˡ
        case '/Response/Body/vacantHotelSearch:VacantHotelSearch/room/settleWay': $this->rooms[$i]['settleWay'] = $text; break;
        // ͽڡURL
        case '/Response/Body/vacantHotelSearch:VacantHotelSearch/room/reserveUrl': $this->rooms[$i]['reserveUrl'] = $text; break;
        // ͽڡեꥨURL
        case '/Response/Body/vacantHotelSearch:VacantHotelSearch/room/reserveAffiliateUrl': $this->rooms[$i]['reserveAffiliateUrl'] = $text; break;

        // 
        case '/Response/Body/vacantHotelSearch:VacantHotelSearch/room/dailyCharge': $this->rooms[$i]['dailyCharge'] = array(); break;
        // ǯ
        case '/Response/Body/vacantHotelSearch:VacantHotelSearch/room/dailyCharge/stayDate': $this->rooms[$i]['dailyCharge']['stayDate'] = $text; break;
        // ̾
        case '/Response/Body/vacantHotelSearch:VacantHotelSearch/room/dailyCharge/regularCharge': $this->rooms[$i]['dailyCharge']['regularCharge'] = $text; break;
        // ŷ
        case '/Response/Body/vacantHotelSearch:VacantHotelSearch/room/dailyCharge/rakutenCharge': $this->rooms[$i]['dailyCharge']['rakutenCharge'] = $text; break;

        case '/Response/Body/vacantHotelSearch:VacantHotelSearch/hotel': $j++; break;
        // ֹ
        case '/Response/Body/vacantHotelSearch:VacantHotelSearch/hotel/hotelNo': $this->hotels[$j]['hotelNo'] = $text; break;
        // ̾
        case '/Response/Body/vacantHotelSearch:VacantHotelSearch/hotel/hotelName': $this->hotels[$j]['hotelName'] = $text; break;
        // ߤ̾
        case '/Response/Body/vacantHotelSearch:VacantHotelSearch/hotel/hotelKanaName': $this->hotels[$j]['hotelKanaName'] = $text; break;
        // ÿ
        case '/Response/Body/vacantHotelSearch:VacantHotelSearch/hotel/hotelSpecial': $this->hotels[$j]['hotelSpecial'] = $text; break;
        // å
        case '/Response/Body/vacantHotelSearch:VacantHotelSearch/hotel/checkinTime': $this->hotels[$j]['checkinTime'] = $text; break;
        // åȻ
        case '/Response/Body/vacantHotelSearch:VacantHotelSearch/hotel/checkoutTime': $this->hotels[$j]['checkoutTime'] = $text; break;
        // 
        case '/Response/Body/vacantHotelSearch:VacantHotelSearch/hotel/latitude': $this->hotels[$j]['latitude'] = $text; break;
        // 
        case '/Response/Body/vacantHotelSearch:VacantHotelSearch/hotel/longitude': $this->hotels[$j]['longitude'] = $text; break;
        // ͹ֹ
        case '/Response/Body/vacantHotelSearch:VacantHotelSearch/hotel/postalCode': $this->hotels[$j]['postalCode'] = $text; break;
        // ꣱
        case '/Response/Body/vacantHotelSearch:VacantHotelSearch/hotel/address1': $this->hotels[$j]['address1'] = $text; break;
        // ꣲ
        case '/Response/Body/vacantHotelSearch:VacantHotelSearch/hotel/address2': $this->hotels[$j]['address2'] = $text; break;
        // ֹ
        case '/Response/Body/vacantHotelSearch:VacantHotelSearch/hotel/telephoneNo': $this->hotels[$j]['telephoneNo'] = $text; break;
        // եåֹ
        case '/Response/Body/vacantHotelSearch:VacantHotelSearch/hotel/faxNo': $this->hotels[$j]['faxNo'] = $text; break;
        // ߤؤΥ
        case '/Response/Body/vacantHotelSearch:VacantHotelSearch/hotel/access': $this->hotels[$j]['access'] = $text; break;
        // Ǵ̾
        case '/Response/Body/vacantHotelSearch:VacantHotelSearch/hotel/nearestStationName': $this->hotels[$j]['nearestStationName'] = $text; break;
        // ־
        case '/Response/Body/vacantHotelSearch:VacantHotelSearch/hotel/parkingInformation': $this->hotels[$j]['parkingInformation'] = $text; break;
        // ۥƥ̥
        case '/Response/Body/vacantHotelSearch:VacantHotelSearch/hotel/hotelClassCode': $this->hotels[$j]['hotelClassCode'] = $text; break;
        // 쥳ɷ (ͽ)
        case '/Response/Body/vacantHotelSearch:VacantHotelSearch/hotel/recordCount': $this->hotels[$j]['recordCount'] = $text; break;
        // ͽǰ
        case '/Response/Body/vacantHotelSearch:VacantHotelSearch/hotel/lowestCharge': $this->hotels[$j]['lowestCharge'] = $text; break;
        // ͽǹ
        case '/Response/Body/vacantHotelSearch:VacantHotelSearch/hotel/highestCharge': $this->hotels[$j]['highestCharge'] = $text; break;
        // ߲URL
        case '/Response/Body/vacantHotelSearch:VacantHotelSearch/hotel/hotelImageUrl': $this->hotels[$j]['hotelImageUrl'] = $text; break;
        // ߾ڡURL
        case '/Response/Body/vacantHotelSearch:VacantHotelSearch/hotel/hotelInformationUrl': $this->hotels[$j]['hotelInformationUrl'] = $text; break;
        // ߾ڡեꥨURL
        case '/Response/Body/vacantHotelSearch:VacantHotelSearch/hotel/hotelAffiliateUrl': $this->hotels[$j]['hotelAffiliateUrl'] = $text; break;
        // ͽ󥻥󥿡ֹ
        case '/Response/Body/vacantHotelSearch:VacantHotelSearch/hotel/reserveTelephoneNo': $this->hotels[$j]['reserveTelephoneNo'] = $text; break;

        // 嵭ʳ
        default: parent::getElement($current_path, $attribute, $text);
        }
    }

    /**
     * 
     *
     * @access public
     * @return array 
     */
    function getRooms()
    {
        return $this->rooms;
    }

    /**
     * ߾
     *
     * @access public
     * @return array ߾
     */
    function getHotels()
    {
        return $this->hotels;
    }
}

?>
