<?php
/**
 * -----------------------------------------------------------------------------
 *
 * SyL - Web Application Framework for PHP
 *
 * PHP version 4 (>= 4.3.x) or 5
 *
 * Copyright (C) 2006-2008 k.watanabe
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * -----------------------------------------------------------------------------
 * @package   SyL
 * @author    Koki Watanabe <k.watanabe@syl.jp>
 * @copyright 2006-2008 k.watanabe
 * @license   http://www.opensource.org/licenses/lgpl-license.php
 * @version   CVS: $Id: SyL_WebServiceAuctionAuctionItemResponse.php,v 1.2 2008/09/11 13:06:59 seasonstream Exp $
 * @link      http://www.syl.jp/
 * -----------------------------------------------------------------------------
 */

/**
 * WEBӥ쥹ݥ󥹥饹Yahoo! Japan -  - ʾܺѡ
 *
 * ܺ٤ϡYahoo!ǥ٥åѡͥåȥ
 *   http://developer.yahoo.co.jp/
 *  - ʾܺ
 *   http://developer.yahoo.co.jp/auctions/rest/auctionitem/V1/auctionitem.html
 *
 * @package   SyL
 * @author    Koki Watanabe <k.watanabe@syl.jp>
 * @copyright 2006-2008 k.watanabe
 * @license   http://www.opensource.org/licenses/lgpl-license.php
 * @version   CVS: $Id: SyL_WebServiceAuctionAuctionItemResponse.php,v 1.2 2008/09/11 13:06:59 seasonstream Exp $
 * @link      http://www.syl.jp/
 */
class SyL_WebServiceAuctionAuctionItemResponse extends SyL_WebServiceYahoo_co_jpResponse
{
    /**
     * ʡʥ˾
     *
     * @access private
     * @var array
     */
    var $item = array();

    /**
     * XMLǡƼϥɥ᥽å
     *
     * @access protected
     * @param string XMLΥѥ
     * @param string XMLΥ°
     * @param string XMLΥ
     */
    function getElement($current_path, $attribute, $text)
    {
        switch ($current_path) {
        // =============================
        // 
        // =============================
        // ʡʥˤID
        case '/AuctionItem/auctionID': $this->item['auctionID'] = $text; break;
        // ƥID
        case '/AuctionItem/categoryID': $this->item['categoryID'] = $text; break;
        // Ǿ̥ƥ꤫Υѥ
        case '/AuctionItem/categoryPath': $this->item['categoryPath'] = $text; break;
        // ʡʥˤΥȥ
        case '/AuctionItem/title': $this->item['title'] = $text; break;
        // ʡʥˤURL
        case '/AuctionItem/url': $this->item['url'] = $text; break;
        // ʼԤ˴ؤ
        case '/AuctionItem/seller': $this->item['seller'] = array(); break;
        // ʼԤYahoo! JAPAN ID
        case '/AuctionItem/seller/id': $this->item['seller']['id'] = $text; break;
        // ϰ
        case '/AuctionItem/seller/location': $this->item['seller']['location'] = $text; break;
        // ʥꥹȤꥯURL
        case '/AuctionItem/seller/itemlist': $this->item['seller']['itemlist'] = $text; break;
        // ʼԤɾΥڡURL
        case '/AuctionItem/seller/rating': $this->item['seller']['rating'] = $text; break;
        // ʥͥˤURL
        case '/AuctionItem/img': $this->item['img'] = $text; break;
        // 1URL
        case '/AuctionItem/image1':
            $this->item['image1'] = array();
            $this->item['image1']['width']  = isset($attribute['width'])  ? $attribute['width']  : null;
            $this->item['image1']['height'] = isset($attribute['height']) ? $attribute['height'] : null;
            $this->item['image1']['url']    = $text;
            break;
        // 2URL
        case '/AuctionItem/image2':
            $this->item['image2'] = array();
            $this->item['image2']['width']  = isset($attribute['width'])  ? $attribute['width']  : null;
            $this->item['image2']['height'] = isset($attribute['height']) ? $attribute['height'] : null;
            $this->item['image2']['url']    = $text;
            break;
        // 3URL
        case '/AuctionItem/image3':
            $this->item['image3'] = array();
            $this->item['image3']['width']  = isset($attribute['width'])  ? $attribute['width']  : null;
            $this->item['image3']['height'] = isset($attribute['height']) ? $attribute['height'] : null;
            $this->item['image3']['url']    = $text;
            break;

        // ϲ
        case '/AuctionItem/initprice': $this->item['initprice'] = $text; break;
        // ߲
        case '/AuctionItem/price': $this->item['price'] = $text; break;
        // ʤο
        case '/AuctionItem/quantity': $this->item['quantity'] = $text; break;
        // ߤ
        case '/AuctionItem/bids': $this->item['bids'] = $text; break;
        // γ
        case '/AuctionItem/starttime': $this->item['starttime'] = $text; break;
        // νλ
        case '/AuctionItem/endtime': $this->item['endtime'] = $text; break;
        // λĤ
        case '/AuctionItem/timeleft': $this->item['timeleft'] = $text; break;
        // ˾
        case '/AuctionItem/bidorbuy': $this->item['bidorbuy'] = $text; break;
        // ʤ̵ͭ
        case '/AuctionItem/reserved': $this->item['reserved'] = $text; break;
        // ʡʥˤΥץ
        case '/AuctionItem/option': $this->item['option'] = array(); break;
        // ʡʥˤΥץ: storeץURL
        case '/AuctionItem/option/store': $this->item['option']['store'] = $text; break;
        // ʡʥˤΥץ: ִѤߡץURL
        case '/AuctionItem/option/check': $this->item['option']['check'] = $text; break;
        // ʡʥˤΥץ: ָץURL
        case '/AuctionItem/option/public': $this->item['option']['public'] = $text; break;
        // ʡʥˤΥץ: ̵ץURL
        case '/AuctionItem/option/freeshipping': $this->item['option']['freeshipping'] = $text; break;
        // ʡʥˤΥץ: ּѥӥץURL
        case '/AuctionItem/option/escrow': $this->item['option']['escrow'] = $text; break;
        // ʡʥˤΥץ: £ʡץURL
        case '/AuctionItem/option/wrappingicon': $this->item['option']['wrappingicon'] = $text; break;
        // ʡʥˤΥץ: ¨ץURL
        case '/AuctionItem/option/buynow': $this->item['option']['buynow'] = $text; break;
        // ʡʥˤΥץ: Yahoo!󤿤ѡץURL
        case '/AuctionItem/option/easypayment': $this->item['option']['easypayment'] = $text; break;
        // ʡʥˤΥץ: ץURL
        case '/AuctionItem/option/largeimg': $this->item['option']['largeimg'] = $text; break;
        // ʡʥˤΥץ: ΩץURL
        case '/AuctionItem/option/gift_icon': $this->item['option']['gift_icon'] = $text; break;
        // 
        case '/AuctionItem/description': $this->item['description'] = $text; break;

        // ¾
        default: parent::getElement($current_path, $attribute, $text); break;
        }
    }

    /**
     * ʡʥ˾
     *
     * @access public
     * @return mixed ʡʥ˾
     */
    function getItem($name=null)
    {
        if ($name !== null) {
            return isset($this->item[$name]) ? $this->item[$name] : null;
        } else {
            return $this->item;
        }
    }
}

?>
