<?php
/**
 * -----------------------------------------------------------------------------
 *
 * SyL - Web Application Framework for PHP
 *
 * PHP version 4 (>= 4.3.x) or 5
 *
 * Copyright (C) 2006-2008 k.watanabe
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * -----------------------------------------------------------------------------
 * @package   SyL
 * @author    Koki Watanabe <k.watanabe@syl.jp>
 * @copyright 2006-2008 k.watanabe
 * @license   http://www.opensource.org/licenses/lgpl-license.php
 * @version   CVS: $Id: SyL_WebServiceAuctionSellingListResponse.php,v 1.2 2008/09/11 13:06:59 seasonstream Exp $
 * @link      http://www.syl.jp/
 * -----------------------------------------------------------------------------
 */

/**
 * WEBӥ쥹ݥ󥹥饹Yahoo! Japan -  - ʥꥹѡ
 *
 * ܺ٤ϡYahoo!ǥ٥åѡͥåȥ
 *   http://developer.yahoo.co.jp/
 *  - ʥꥹ
 *   http://developer.yahoo.co.jp/auctions/rest/sellinglist/V1/sellinglist.html
 *
 * @package   SyL
 * @author    Koki Watanabe <k.watanabe@syl.jp>
 * @copyright 2006-2008 k.watanabe
 * @license   http://www.opensource.org/licenses/lgpl-license.php
 * @version   CVS: $Id: SyL_WebServiceAuctionSellingListResponse.php,v 1.2 2008/09/11 13:06:59 seasonstream Exp $
 * @link      http://www.syl.jp/
 */
class SyL_WebServiceAuctionSellingListResponse extends SyL_WebServiceYahoo_co_jpResponse
{
    /**
     * ˰פʡʥˤ 
     *
     * @access private
     * @var int
     */
    var $total_auctions = null;
    /**
     * ˰פڡ
     *
     * @access private
     * @var int
     */
    var $total_page = null;
    /**
     * ߤΥڡֹ
     *
     * @access private
     * @var string
     */
    var $cur_page = null;
    /**
     * ʼԾ
     *
     * @access private
     * @var array
     */
     var $seller = array();
    /**
     * ʡʥ˾
     *
     * @access private
     * @var array
     */
    var $items = array();

    /**
     * XMLǡƼϥɥ᥽å
     *
     * @access protected
     * @param string XMLΥѥ
     * @param string XMLΥ°
     * @param string XMLΥ
     */
    function getElement($current_path, $attribute, $text)
    {
        static $item_i = -1;

        switch ($current_path) {
        // =============================
        // 
        // =============================
        case '/AuctionSellingList':
            if (isset($attribute['totalAuctions'])) {
                $this->total_auctions = $attribute['totalAuctions'];
            }
            if (isset($attribute['totalPage'])) {
                $this->total_page = $attribute['totalPage'];
            }
            if (isset($attribute['curPage'])) {
                $this->cur_page = $attribute['curPage'];
            }
            break;

        // ʼԤYahoo! JAPAN ID
        case '/AuctionSellingList/seller/id': $this->seller['id'] = $text; break;
        // ʼԤνʥꥹȤꥯURL
        case '/AuctionSellingList/seller/itemlist': $this->seller['itemlist'] = $text; break;
        // ʼԤμʾҲڡURL
        case '/AuctionSellingList/seller/about': $this->seller['about'] = $text; break;
        // ʼԤɾΥڡURL
        case '/AuctionSellingList/seller/rating': $this->seller['rating'] = $text; break;

        // ʡʥ˾
        case '/AuctionSellingList/item': $item_i++; break;
        // ʡʥˤID
        case '/AuctionSellingList/item/auctionID': $this->items[$item_i]['auctionID'] = $text; break;
        // ʡʥˤΥȥ
        case '/AuctionSellingList/item/title': $this->items[$item_i]['title'] = $text; break;
        // ʾܺ١ʥ˥ڡURL
        case '/AuctionSellingList/item/url': $this->items[$item_i]['url'] = $text; break;
        // ʥͥˤURL
        case '/AuctionSellingList/item/img': $this->items[$item_i]['img'] = $text; break;
        // ߲
        case '/AuctionSellingList/item/price': $this->items[$item_i]['price'] = $text; break;
        // ߤ
        case '/AuctionSellingList/item/bids': $this->items[$item_i]['bids'] = $text; break;
        // νλ
        case '/AuctionSellingList/item/endtime': $this->items[$item_i]['endtime'] = $text; break;
        // ʤ̵ͭ
        case '/AuctionSellingList/item/reserved': $this->items[$item_i]['reserved'] = $text; break;
        // ʡʥˤΥץ
        case '/AuctionSellingList/item/option': $this->items[$item_i]['option'] = array(); break;
        // ʡʥˤΥץ: newץURL
        case '/AuctionSellingList/item/option/new': $this->items[$item_i]['option']['new'] = $text; break;
        // ʡʥˤΥץ: storeץURL
        case '/AuctionSellingList/item/option/store': $this->items[$item_i]['option']['store'] = $text; break;
        // ʡʥˤΥץ: ִѤߡץURL
        case '/AuctionSellingList/item/option/check': $this->items[$item_i]['option']['check'] = $text; break;
        // ʡʥˤΥץ: ָץURL
        case '/AuctionSellingList/item/option/public': $this->items[$item_i]['option']['public'] = $text; break;
        // ʡʥˤΥץ: ̵ץURL
        case '/AuctionSellingList/item/option/freeshipping': $this->items[$item_i]['option']['freeshipping'] = $text; break;
        // ʡʥˤΥץ: ּѥӥץURL
        case '/AuctionSellingList/item/option/escrow': $this->items[$item_i]['option']['escrow'] = $text; break;
        // ʡʥˤΥץ: £ʡץURL
        case '/AuctionSellingList/item/option/wrappingicon': $this->items[$item_i]['option']['wrappingicon'] = $text; break;
        // ʡʥˤΥץ: ¨ץURL
        case '/AuctionSellingList/item/option/buynow': $this->items[$item_i]['option']['buynow'] = $text; break;
        // ʡʥˤΥץ: Yahoo!󤿤ѡץURL
        case '/AuctionSellingList/item/option/easypayment': $this->items[$item_i]['option']['easypayment'] = $text; break;
        // ʡʥˤΥץ: ץURL
        case '/AuctionSellingList/item/option/largeimg': $this->items[$item_i]['option']['largeimg'] = $text; break;
        // ʡʥˤΥץ: ΩץURL
        case '/AuctionSellingList/item/option/gift_icon': $this->items[$item_i]['option']['gift_icon'] = $text; break;

        // ¾
        default: parent::getElement($current_path, $attribute, $text); break;
        }
    }

    /**
     * ˰פʡʥˤ
     *
     * @access public
     * @return int ˰פʡʥˤ
     */
    function getTotalAuctions()
    {
        return $this->total_auctions;
    }

    /**
     * ˰פڡ
     *
     * @access public
     * @return int ˰פڡ
     */
    function getTotalPage()
    {
        return $this->total_page;
    }

    /**
     * ߤΥڡֹ
     *
     * @access public
     * @return int ߤΥڡֹ
     */
    function getCurPage()
    {
        return $this->cur_page;
    }

    /**
     * ʼԾ
     *
     * @access public
     * @param string 
     * @return mixed ʼԾ
     */
    function getSeller($name=null)
    {
        if ($name !== null) {
            return isset($this->seller[$name]) ? $this->seller[$name] : null;
        } else {
            return $this->seller;
        }
    }

    /**
     * ʡʥ˾
     *
     * @access public
     * @return array ʡʥ˾
     */
    function getItems()
    {
        return $this->items;
    }
}

?>
