<?php
/**
 * -----------------------------------------------------------------------------
 *
 * SyL - Web Application Framework for PHP
 *
 * PHP version 4 (>= 4.3.x) or 5
 *
 * Copyright (C) 2006-2008 k.watanabe
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * -----------------------------------------------------------------------------
 * @package   SyL
 * @author    Koki Watanabe <k.watanabe@syl.jp>
 * @copyright 2006-2008 k.watanabe
 * @license   http://www.opensource.org/licenses/lgpl-license.php
 * @version   CVS: $Id: SyL_WebServiceJlpDAServiceResponse.php,v 1.1 2008/09/11 13:06:59 seasonstream Exp $
 * @link      http://www.syl.jp/
 * -----------------------------------------------------------------------------
 */

/**
 * WEBӥ쥹ݥ󥹥饹Yahoo! Japan - ܸ췸Webӥ
 *
 * ܺ٤ϡYahoo!ǥ٥åѡͥåȥ
 *   http://developer.yahoo.co.jp/
 * ܸ췸Webӥ
 *   http://developer.yahoo.co.jp/jlp/DAService/V1/parse.html
 *
 * @package   SyL
 * @author    Koki Watanabe <k.watanabe@syl.jp>
 * @copyright 2006-2008 k.watanabe
 * @license   http://www.opensource.org/licenses/lgpl-license.php
 * @version   CVS: $Id: SyL_WebServiceJlpDAServiceResponse.php,v 1.1 2008/09/11 13:06:59 seasonstream Exp $
 * @link      http://www.syl.jp/
 */
class SyL_WebServiceJlpDAServiceResponse extends SyL_WebServiceYahoo_co_jpResponse
{
    /**
     * Ϸ
     *
     * @access private
     * @var array
     */
     var $results = array();

    /**
     * XMLǡƼϥɥ᥽å
     *
     * @access protected
     * @param string XMLΥѥ
     * @param string XMLΥ°
     * @param string XMLΥ
     */
    function getElement($current_path, $attribute, $text)
    {
        static $i = -1;
        static $j = -1;

        switch ($current_path) {
        // =============================
        // 
        // =============================
        // ʸξ
        case '/ResultSet/Result/ChunkList/Chunk': $i++; break;
        // ʸֹ
        case '/ResultSet/Result/ChunkList/Chunk/Id': $this->results[$i]['Id'] = $text; break;
        // Id
        case '/ResultSet/Result/ChunkList/Chunk/Dependency': $this->results[$i]['Dependency'] = $text; break;
        // ǾΥꥹ
        case '/ResultSet/Result/ChunkList/Chunk/MorphemList': $this->results[$i]['MorphemeList'] = array(); $j = -1; break;
        // Ǥξ
        case '/ResultSet/Result/ChunkList/Chunk/MorphemList/Morphem': $j++; break;
        // Ǥɽ
        case '/ResultSet/Result/ChunkList/Chunk/MorphemList/Morphem/Surface': $this->results[$i]['MorphemeList'][$j]['Surface'] = $text; break;
        // Ǥɤߤ
        case '/ResultSet/Result/ChunkList/Chunk/MorphemList/Morphem/Reading': $this->results[$i]['MorphemeList'][$j]['Reading'] = $text; break;
        // Ǥδܷɽ
        case '/ResultSet/Result/ChunkList/Chunk/MorphemList/Morphem/BaseForm': $this->results[$i]['MorphemeList'][$j]['BaseForm'] = $text; break;
        // Ǥʻ
        case '/ResultSet/Result/ChunkList/Chunk/MorphemList/Morphem/POS': $this->results[$i]['MorphemeList'][$j]['POS'] = $text; break;
        // Ǥ
        case '/ResultSet/Result/ChunkList/Chunk/MorphemList/Morphem/Feature': $this->results[$i]['MorphemeList'][$j]['Feature'] = $text; break;

        // ¾
        default: parent::getElement($current_path, $attribute, $text); break;
        }
    }

    /**
     * Ϸ̤
     *
     * @access public
     * @return array Ϸ
     */
    function getResults()
    {
        return $this->results;
    }
}

?>
