<?php
/**
 * -----------------------------------------------------------------------------
 *
 * SyL - Web Application Framework for PHP
 *
 * PHP version 4 (>= 4.3.x) or 5
 *
 * Copyright (C) 2006-2008 k.watanabe
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * -----------------------------------------------------------------------------
 * @package   SyL
 * @author    Koki Watanabe <k.watanabe@syl.jp>
 * @copyright 2006-2008 k.watanabe
 * @license   http://www.opensource.org/licenses/lgpl-license.php
 * @version   CVS: $Id: SyL_WebServiceJlpFuriganaServiceResponse.php,v 1.1 2008/09/11 13:06:59 seasonstream Exp $
 * @link      http://www.syl.jp/
 * -----------------------------------------------------------------------------
 */

/**
 * WEBӥ쥹ݥ󥹥饹Yahoo! Japan - ӿWebӥ
 *
 * ܺ٤ϡYahoo!ǥ٥åѡͥåȥ
 *   http://developer.yahoo.co.jp/
 * ӿWebӥ
 *   http://developer.yahoo.co.jp/jlp/FuriganaService/V1/furigana.html
 *
 * @package   SyL
 * @author    Koki Watanabe <k.watanabe@syl.jp>
 * @copyright 2006-2008 k.watanabe
 * @license   http://www.opensource.org/licenses/lgpl-license.php
 * @version   CVS: $Id: SyL_WebServiceJlpFuriganaServiceResponse.php,v 1.1 2008/09/11 13:06:59 seasonstream Exp $
 * @link      http://www.syl.jp/
 */
class SyL_WebServiceJlpFuriganaServiceResponse extends SyL_WebServiceYahoo_co_jpResponse
{
    /**
     * ñΥꥹ
     *
     * @access private
     * @var array
     */
     var $results = array();

    /**
     * XMLǡƼϥɥ᥽å
     *
     * @access protected
     * @param string XMLΥѥ
     * @param string XMLΥ°
     * @param string XMLΥ
     */
    function getElement($current_path, $attribute, $text)
    {
        static $i = -1;
        static $j = -1;

        switch ($current_path) {
        // =============================
        // 
        // =============================
        // ñ
        case '/ResultSet/Result/WordList/Word': $i++; break;
        // ñɽ
        case '/ResultSet/Result/WordList/Word/Surface': $this->results[$i]['Surface'] = $text; break;
        // ñΤߤҤ餬
        case '/ResultSet/Result/WordList/Word/Furigana': $this->results[$i]['Furigana'] = $text; break;
        // ñΤߤ޻
        case '/ResultSet/Result/WordList/Word/Roman': $this->results[$i]['Roman'] = $text; break;
        // ˺٤ʬȤҤ餬ʬʬ䤷̤Υꥹ
        case '/ResultSet/Result/WordList/Word/SubWordList': $this->results[$i]['SubWordList'] = array(); $j = -1; break;
        // ʬȤҤ餬ʬʬ䤷
        case '/ResultSet/Result/WordList/Word/SubWordList/SubWord': $j++; break;
        // ñɽ
        case '/ResultSet/Result/WordList/Word/SubWordList/SubWord/Surface': $this->results[$i]['SubWordList'][$j]['Surface'] = $text; break;
        // ñΤߤҤ餬
        case '/ResultSet/Result/WordList/Word/SubWordList/SubWord/Furigana': $this->results[$i]['SubWordList'][$j]['Furigana'] = $text; break;
        // ñΤߤ޻
        case '/ResultSet/Result/WordList/Word/SubWordList/SubWord/Roman': $this->results[$i]['SubWordList'][$j]['Roman'] = $text; break;

        // ¾
        default: parent::getElement($current_path, $attribute, $text); break;
        }
    }

    /**
     * ñΥꥹȤ
     *
     * @access public
     * @return array ñΥꥹ
     */
    function getResults()
    {
        return $this->results;
    }
}

?>
