<?php
/**
 * -----------------------------------------------------------------------------
 *
 * SyL - Web Application Framework for PHP
 *
 * PHP version 4 (>= 4.3.x) or 5
 *
 * Copyright (C) 2006-2008 k.watanabe
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * -----------------------------------------------------------------------------
 * @package   SyL
 * @author    Koki Watanabe <k.watanabe@syl.jp>
 * @copyright 2006-2008 k.watanabe
 * @license   http://www.opensource.org/licenses/lgpl-license.php
 * @version   CVS: $Id: SyL_WebServiceMinnaCertCertListResponse.php,v 1.3 2008/09/29 14:41:37 seasonstream Exp $
 * @link      http://www.syl.jp/
 * -----------------------------------------------------------------------------
 */

/**
 * WEBӥ쥹ݥ󥹥饹Yahoo! Japan - ߤʤθ ꥹWebӥ
 *
 * ܺ٤ϡYahoo!ǥ٥åѡͥåȥ
 *   http://developer.yahoo.co.jp/
 * ߤʤθ ꥹWebӥ
 *   http://developer.yahoo.co.jp/minna_cert/certlist/V1/certlist.html
 *
 * @package   SyL
 * @author    Koki Watanabe <k.watanabe@syl.jp>
 * @copyright 2006-2008 k.watanabe
 * @license   http://www.opensource.org/licenses/lgpl-license.php
 * @version   CVS: $Id: SyL_WebServiceMinnaCertCertListResponse.php,v 1.3 2008/09/29 14:41:37 seasonstream Exp $
 * @link      http://www.syl.jp/
 */
class SyL_WebServiceMinnaCertCertListResponse extends SyL_WebServiceYahoo_co_jpResponse
{
    /**
     * ǡΥޥå꡼
     *
     * @access private
     * @var int 
     */
     var $total_results_available = 0;
    /**
     * ֵѤ졢ĥޥå꡼ο
     *
     * @access private
     * @var int 
     */
    var $total_results_returned = 0;
    /**
     * ̤κǽΥݥ
     *
     * @access private
     * @var int 
     */
    var $first_result_position = 0;
    /**
     * ̥ǡ
     *
     * @access private
     * @var array
     */
    var $results = array();

    /**
     * XMLǡƼϥɥ᥽å
     *
     * @access protected
     * @param string XMLΥѥ
     * @param string XMLΥ°
     * @param string XMLΥ
     */
    function getElement($current_path, $attribute, $text)
    {
        static $i = -1;

        switch ($current_path) {
        // =============================
        // 
        // =============================
        case '/ResultSet':
            if (isset($attribute['totalResultsAvailable'])) {
                $this->total_results_available = $attribute['totalResultsAvailable'];
            }
            if (isset($attribute['totalResultsReturned'])) {
                $this->total_results_returned = $attribute['totalResultsReturned'];
            }
            if (isset($attribute['firstResultPosition'])) {
                $this->first_result_position = $attribute['firstResultPosition'];
            }
            break;
        case '/ResultSet/Result': $i++; break;
        // ID
        case '/ResultSet/Result/CertId': $this->results[$i]['CertId'] = $text; break;
        // ̾
        case '/ResultSet/Result/CertName': $this->results[$i]['CertName'] = $text; break;
        // ʬ
        case '/ResultSet/Result/CertDiv': $this->results[$i]['CertDiv'] = $text; break;
        // 
        case '/ResultSet/Result/UserName': $this->results[$i]['UserName'] = $text; break;
        // URL
        case '/ResultSet/Result/CertImageUrl': $this->results[$i]['CertImageUrl'] = $text; break;
        // 공
        case '/ResultSet/Result/CertOverview': $this->results[$i]['CertOverview'] = $text; break;
        // θ
        case '/ResultSet/Result/OpenDate': $this->results[$i]['OpenDate'] = $text; break;
        // 
        case '/ResultSet/Result/QuestionCount': $this->results[$i]['QuestionCount'] = $text; break;
        // ݡȸե饰
        case '/ResultSet/Result/ReportOpenFlag': $this->results[$i]['ReportOpenFlag'] = $text; break;
        // ʴ
        case '/ResultSet/Result/Correct': $this->results[$i]['Correct'] = $text; break;
        // 
        case '/ResultSet/Result/ExamAmount': $this->results[$i]['ExamAmount'] = $text; break;
        // ʼ
        case '/ResultSet/Result/PassAmount': $this->results[$i]['PassAmount'] = $text; break;
        // θϿѼԤο
        case '/ResultSet/Result/FavoredCertCount': $this->results[$i]['FavoredCertCount'] = $text; break;
        // Ƥ줿ȿ
        case '/ResultSet/Result/CommentCount': $this->results[$i]['CommentCount'] = $text; break;
        // ɾݥȤʿ
        case '/ResultSet/Result/EvalPoint': $this->results[$i]['EvalPoint'] = $text; break;
        // ݥ
        case '/ResultSet/Result/TotalPoint': $this->results[$i]['TotalPoint'] = $text; break;
        // ѥǤθܺ٥ڡURL
        case '/ResultSet/Result/CertDetailPcUrl': $this->results[$i]['CertDetailPcUrl'] = $text; break;
        // ХǤθܺ٥ڡURL
        case '/ResultSet/Result/CertDetailMbUrl': $this->results[$i]['CertDetailMbUrl'] = $text; break;

        // ¾
        default: parent::getElement($current_path, $attribute, $text); break;
        }
    }

    /**
     * ǡΥޥå꡼
     *
     * @access public
     * @return int ǡΥޥå꡼
     */
    function getTotalResultsAvailable()
    {
        return $this->total_results_available;
    }

    /**
     * ֵѤ졢ĥޥå꡼ο
     *
     * @access public
     * @return int ֵѤ졢ĥޥå꡼ο
     */
    function getTotalResultsReturned()
    {
        return $this->total_results_returned;
    }

    /**
     * ֵѤ졢ĥޥå꡼ο
     *
     * @access public
     * @return int ֵѤ졢ĥޥå꡼ο
     */
    function getFirstResultPosition()
    {
        return $this->first_result_position;
    }

    /**
     * ̥ǡ
     *
     * @access public
     * @return array ̥ǡ
     */
    function getResults()
    {
        return $this->results;
    }
}

?>
